; тест проверки переключения страниц БК11 в верхнем окне
OFSF8=400
SYNCW=51400

SCRCRD=160
SCRY=156
SCRFNT=166
SCRLNC=164
MEMREG=114

                mov     #100, @#177660
                mtps    #340
                cmpb    #300, @#177717      ; если не БК11
                beq     3$
                halt                        ; дальше не работает

3$:             mov     #16000, @#MEMREG
                call    SCRINI
; идея следующая.
; 1. подключаем страницу в окно1 и заполняем данными
; 2. переключаем её в окно0 и проверяем, что там получилось
; 3. снова заполняем данными страницу
; 4. обратно переключаем её в окно1 и проверяем, что получилось.
                mov     #1, R5              ; номер проверяемой страницы, стр 0 не трогаем.
0LOOP:          mov     #TX1, R1
                call    OUTSTR              ; говорим, что работаем со страницей
                mov     R5, R1              ; номер такой-то
                call    DGOUT
                mov     #T$PP1, R1
                call    OUTSTR
                mov     R5, R0
                call    SETP1               ; подрубаем её в окно 1
                mov     #T$FILL, R1
                call    OUTSTR
                call    FILL1               ; заполняем данные
                call    CRC1                ; считаем CRC
                mov     R0, R4              ; сохраняем
                mov     #T$PP0, R1
                call    OUTSTR
                mov     R5, R0
                call    SETP0               ; подрубаем её в окно 0
                mov     #T$CHCK, R1
                call    OUTSTR
                call    CRC0                ; считаем CRC
                mov     #T$STP1, R1
                call    OUTSTR
                mov     #T$OK, R1
                cmp     R4, R0
                beq     0$
                mov     #T$FAIL, R1
0$:             call    OUTSTR
                call    FILL0               ; заполняем данные
                call    CRC0                ; считаем CRC
                mov     R0, R4              ; сохраняем
                mov     #T$PP1, R1
                call    OUTSTR
                mov     R5, R0
                call    SETP1               ; подрубаем её в окно 1
                mov     #T$CHCK, R1
                call    OUTSTR
                call    CRC1                ; считаем CRC
                mov     #T$STP0, R1
                call    OUTSTR
                mov     #T$OK, R1
                cmp     R4, R0
                beq     1$
                mov     #T$FAIL, R1
1$:             call    OUTSTR
                mov     #12, R0
                call    PUTCH
                call    PUTCH
2$:             inc     R5
                cmp     R5, #5              ; экран пропускаем. может потом можно будет что-нибудь придумать
                beq     2$
                cmp     R5, #10
                blo     0LOOP
                mov     #TX2, R1
                call    OUTSTR
                mov     #PRANYK, R1
                call    OUTSTR
                call    EMT6
                jmp     @#140000


FILL0:          jsr     R5, PUSHA
                mov     #40000, R1
                br      0FILL
FILL1:          jsr     R5, PUSHA
                mov     #100000, R1
0FILL:          mov     #20000, R0
0:              mov     R0, R2
                xor     R1, R2
                mov     R2, (R1)+
                sob     R0, 0
                return

CRC0:           mov     R2, -(SP)
                mov     R1, -(SP)
                mov     #40000, R1
                br      0CRC
CRC1:           mov     R2, -(SP)
                mov     R1, -(SP)
                mov     #100000, R1
0CRC:           mov     #20000, R2
                clr     R0
0$:             add     (R1)+, R0
                adc     R0
                sob     R2, 0$
                mov     (SP)+, R1
                mov     (SP)+, R2
                return


; вызов так: jsr R5, PUSHA, сохраняем все регистры
; но в R5 нельзя передать параметр, чтобы было можно, есть более сложный метод
PUSHA:          mov     R4, -(SP)
                mov     R3, -(SP)
                mov     R2, -(SP)
                mov     R1, -(SP)
                mov     R0, -(SP)
                ; mov    R5, -(SP)       ; это - чтобы и в r5 можно было
                ; mov    14(SP), R5      ; передавать параметры
                ; call   @(SP)+
                call    (R5)
                mov     (SP)+, R0
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                mov     (SP)+, R4
                mov     (SP)+, R5
                return

; вывод числа из R1, с подавлением ведущих нулей
DGOUT:          jsr     R5, PUSHA
                mov     #16000, @#177716
                mov     #6, R4              ; максимальное кол-во цифр в числе
                clr     R5                  ; счётчик цифр
0$:             mov     R1, R0
                bic     #177770, R0         ; получим очередную цифру
                add     #'0, R0
                mov     R0, -(SP)           ; в стек её
                inc     R5
                ror     R1                  ; пододвинем следующую, ADD бит С обнуляет, так что можно
                asr     R1
                asr     R1                  ; цифры остались?
                beq     1$                  ; кончились - выход, если число отрицательное, то мы отработает все 6 цифр.
                sob     R4, 0$
1$:             mov     (SP)+, R0
                call    PUTCH$
                sob     R5, 1$
                jmp     SETPG

EMT6:           call    KEYPRS
                bne     EMT6
                movb    @#177662, R0
                return
KEYPRS:         bit     #100, @#177716
                return


; собственный знакогенератор
; инициализация экрана
SCRINI:         mov     #40000, R1
                mov     R1, R0
                mov     R1, @#SCRCRD
                clr     @#SCRY              ; Y координата, для рулонного сдвига
                clr     @#SCRLNC            ; счётчик строк
                mov     #1330, @#177664
1:              clrb    (R1)+
                sob     R0, 1
                mov     #FONT8, R1
                mov     #34000, R2
                mov     R2, R0
                sub     #400, R0
                mov     R0, @#SCRFNT
                mov     #3000, R0
2:              movb    (R1)+, (R2)+
                sob     R0, 2
                return

; вывод строки. Вход: R1 - адрес строки
OUTSTR:         mov     R0, -(SP)
                mov     #16000, @#177716    ; с подключением экрана
3$:             movb    (R1)+, R0           ; Портит R0
                beq     1$
                call    PUTCH
                br      3$
1$:             call    SETPG
                mov     (SP)+, R0
                return

OUTST$:         mov     R0, -(SP)           ; без переключения экранов
3$:             movb    (R1)+, R0           ; Портит R0
                beq     1$
                call    PUTCH$
                br      3$
1$:             mov     (SP)+, R0
                return


PUTCH:          jsr     R5, PUSHA           ; с подключением экрана
                mov     #16000, @#177716
                call    PUT$IN
                jmp     SETPG

PUTCH$:         jsr     R5, PUSHA           ; без переключения экранов
PUT$IN:         bic     #177400, R0
                bitb    #140, R0
                bne     01
                ; обрабатываем спецсимволы
                mov     @#SCRCRD, R3
                cmp     #15, R0
                bne     23
                bic     #77, R3
                br      31
23:             cmp     #12, R0
                bne     21
                bic     #77, R3
                br      22
21:             cmp     #10, R0
                bne     20
                bit     #77, R3
                beq     20
                dec     @#SCRCRD
                br      20
01:             tstb    R0
                bpl     02
                sub     #40, R0
02:             asl     R0
                ; mov    R0, R2
                asl     R0
                asl     R0
                ; add    R2, R0
                add     @#SCRFNT, R0
                mov     #10, R2
                mov     @#SCRCRD, R1
                mov     R1, R3
03:             movb    (R0)+, (R1)
                add     #100, R1
                bpl     04
                sub     #40000, R1
04:             sob     R2, 03
                ; двигаем адрес вывода
05:             mov     R3, R1
                mov     #177700, R0
                bic     R0, R1
                com     R0
                cmp     R1, R0              ; дошли до конца строки?
                bhis    10                  ; да, надо делать перевод строки
                inc     @#SCRCRD            ; нет, просто на следующую позицию вправо
                br      20
10:             bic     R0, R3
22:             inc     @#SCRLNC
                add     #1000, R3           ; высота символов 8 точек
                bpl     11
                sub     #40000, R3          ; это новая координата
11:             mov     R3, R2              ; если делать рулонный сдвиг, то прежде надо будет очистить от старого текста
                cmp     @#SCRY, #37         ; Если мы в самом низу
                bhis    13                  ; то увеличивать координату больше не надо
                inc     @#SCRY              ; иначе увеличим
                br      31
13:             ; делаем рулонный сдвиг
                mov     @#177664, R0
                bic     #177400, R0
                mov     #10, R1             ; высота символов 8 точек
15:             mov     #40, R4
14:             clr     (R2)+
                sob     R4, 14
                tst     R2
                bpl     16
                sub     #40000, R2
16:             incb    R0
                bis     #1000, R0
                mov     R0, @#177664
                sob     R1, 15
31:             mov     R3, @#SCRCRD
                cmp     @#SCRLNC, #37
                blt     20
                mov     #-1, @#SCRLNC
                mov     #PRANYK, R1
                call    OUTST$
32:             call    KEYPRS
                bne     32
                tst     @#177662
33:             call    KEYPRS
                beq     33
                mov     #12, R0
                call    PUTCH$
20:             return

; подключение нужной страницы в окно 1
; вход: R0 - номер страницы
SETP1:          cmp     R0, #10
                bhis    0EX
                mov     R1, -(SP)
                mov     @#MEMREG, R1
                bic     #3400, R1
                asl     R0
                bis     NUMP1(R0), R1
                br      0SET
; подключение нужной страницы в окно 0
; вход: R0 - номер страницы
SETP0:          cmp     R0, #10
                bhis    0EX
                mov     R1, -(SP)
                mov     @#MEMREG, R1
                bic     #70000, R1
                asl     R0
                bis     NUMP0(R0), R1
0SET:           bis     #4000, R1
                mov     R1, @#MEMREG
                asr     R0
                mov     (SP)+, R1
SETPG:          mov     @#MEMREG, @#177716
0EX:            return

NUMP0:          .word   60000, 00000, 20000, 30000, 40000, 10000, 70000, 50000
NUMP1:          .word   3000, 0000, 1000, 1400, 2000, 0400, 3400, 2400

PRANYK:         .asciz  "           *** Нажмите любую клавишу. ***"
TX2:            .asciz  <12>"Тест закончен."<12>
TX1:            .asciz  "Проверяем страницу: "
T$PP1:          .asciz  <12>"Подключаем в окно 1"
T$PP0:          .asciz  <12>"Подключаем в окно 0"
T$STP1:         .asciz  <12>"Окно 1: "
T$STP0:         .asciz  <12>"Окно 0: "
T$FILL:         .asciz  " заполняем"
T$CHCK:         .asciz  " проверяем"
T$OK:           .asciz  "OK  "
T$FAIL:         .asciz  "FAIL  "
                .even

                .end


